#include <allegro5/allegro_primitives.h>

#include "particle.h"

Particle::Particle() {
	active = false;
}

void Particle::init(Vector2 pos, Vector2 speed, int life) {
	active = true;
	this->pos = pos;
	this->speed = speed;
	maxLife = this->life = life;
}

void Particle::logic() {
	if (!active) return;
	life--;
	if (life < 1) {
		active = false;
		return;
	}
	pos += speed;
	if (pos.x < 0) {
		pos.x = 640;
	}
	if (pos.x > 640) {
		pos.x = 0;
	}
	if (pos.y < 0) {
		pos.y = 480;
	}
	if (pos.y > 480) {
		pos.y = 0;
	}
}

void Particle::draw() {
	if (active) {
		al_draw_filled_circle(pos.x, pos.y, 2, al_map_rgba_f(1.0, 1.0, 1.0, (life / (float)maxLife)));
	}
}
